## docker.io 20.10.5+dfsg1

=== Makefile ===
#
# github.com/docker/cli
#
all: binary


_:=$(shell ./scripts/warn-outside-container $(MAKECMDGOALS))

.PHONY: clean
clean: ## remove build artifacts
	rm -rf ./build/* cli/winresources/rsrc_* ./man/man[1-9] docs/yaml/gen

.PHONY: test-unit
test-unit: ## run unit tests, to change the output format use: GOTESTSUM_FORMAT=(dots|short|standard-quiet|short-verbose|standard-verbose) make test-unit 
	gotestsum $(TESTFLAGS) -- $${TESTDIRS:-$(shell go list ./... | grep -vE '/vendor/|/e2e/')}

.PHONY: test
test: test-unit ## run tests

.PHONY: test-coverage
test-coverage: ## run test coverage
	gotestsum -- -coverprofile=coverage.txt $(shell go list ./... | grep -vE '/vendor/|/e2e/')

.PHONY: fmt
fmt:
	go list -f {{.Dir}} ./... | xargs gofmt -w -s -d

.PHONY: lint
lint: ## run all the lint tools
	gometalinter --config gometalinter.json ./...

.PHONY: binary
binary: ## build executable for Linux
	@echo "WARNING: binary creates a Linux executable. Use cross for macOS or Windows."
	./scripts/build/binary

.PHONY: plugins
plugins: ## build example CLI plugins
	./scripts/build/plugins

.PHONY: cross
cross: ## build executable for macOS and Windows
	./scripts/build/cross

.PHONY: binary-windows
binary-windows: ## build executable for Windows
	./scripts/build/windows

.PHONY: plugins-windows
plugins-windows: ## build example CLI plugins for Windows
	./scripts/build/plugins-windows

.PHONY: binary-osx
binary-osx: ## build executable for macOS
	./scripts/build/osx

.PHONY: plugins-osx
plugins-osx: ## build example CLI plugins for macOS
	./scripts/build/plugins-osx

.PHONY: dynbinary
dynbinary: ## build dynamically linked binary
	./scripts/build/dynbinary

vendor: vendor.conf ## check that vendor matches vendor.conf
	rm -rf vendor
	bash -c 'vndr |& grep -v -i clone | tee ./vndr.log'
	scripts/validate/check-git-diff vendor
	scripts/validate/check-all-packages-vendored

.PHONY: authors
authors: ## generate AUTHORS file from git history
	scripts/docs/generate-authors.sh

.PHONY: manpages
manpages: ## generate man pages from go source and markdown
	scripts/docs/generate-man.sh

.PHONY: yamldocs
yamldocs: ## generate documentation YAML files consumed by docs repo
	scripts/docs/generate-yaml.sh

.PHONY: shellcheck
shellcheck: ## run shellcheck validation
	scripts/validate/shellcheck

.PHONY: help
help: ## print this help
	@awk 'BEGIN {FS = ":.*?## "} /^[a-zA-Z0-9_-]+:.*?## / {gsub("\\\\n",sprintf("\n%22c",""), $$2);printf "\033[36m%-20s\033[0m %s\n", $$1, $$2}' $(MAKEFILE_LIST)


cli/compose/schema/bindata.go: cli/compose/schema/data/*.json
	go generate github.com/docker/cli/cli/compose/schema

compose-jsonschema: cli/compose/schema/bindata.go ## generate compose-file schemas
	scripts/validate/check-git-diff cli/compose/schema/bindata.go

.PHONY: ci-validate
ci-validate:
	time make -B vendor
	time make -B compose-jsonschema
	time make manpages
	time make yamldocs

=== debian/changelog ===
docker.io (20.10.5+dfsg1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release 20.10.5
    Same as 20.10.4 but a patch in docker/cli is reverted to fix hanging in
    "docker start --attach" and remove spurious "Unsupported signal: <nil>.
    Discarding" messages.

 -- Shengjing Zhu <zhsj@debian.org>  Wed, 10 Mar 2021 00:53:21 +0800

=== debian/control ===
Source: docker.io
Section: admin
Priority: optional
Standards-Version: 4.5.1
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Arnaud Rebillout <elboulangero@gmail.com>
          ,Dmitry Smirnov <onlyjob@debian.org>
          ,Tim Potter <tpot@hpe.com>
          ,Tianon Gravi <tianon@debian.org>
          ,Paul Tagliamonte <paultag@debian.org>
Build-Conflicts: golang-github-docker-docker-dev
Build-Depends: debhelper-compat (= 13) ,dh-apparmor ,dh-golang (>= 1.14~)
    ,bash-completion
    ,ca-certificates
    ,golang-any (>= 2:1.10~)
    ,go-md2man (>= 1.0.3~)
    ,gogoprotobuf, libprotobuf-dev
    ,golang-dbus-dev (>= 5.0.2~)
    ,golang-etcd-server-dev
    ,golang-github-armon-go-metrics-dev
    ,golang-github-aws-aws-sdk-go-dev
    ,golang-github-bsphere-le-go-dev
    ,golang-github-burntsushi-toml-dev
    ,golang-github-cespare-xxhash-dev
    ,golang-github-cilium-ebpf-dev
    ,golang-github-cloudflare-cfssl-dev
    ,golang-github-containerd-cgroups-dev
    ,golang-github-containerd-console-dev
    ,golang-github-containerd-containerd-dev (>= 1.4.2~ds1-2~)
    ,golang-github-containerd-continuity-dev (>= 0.0~git20190426~)
    ,golang-github-containerd-fifo-dev
    ,golang-github-containerd-go-runc-dev
    ,golang-github-containerd-typeurl-dev
    ,golang-github-coreos-bbolt-dev
    ,golang-github-coreos-go-systemd-dev (>= 20~)
    ,golang-github-creack-pty-dev
    ,golang-github-cyphar-filepath-securejoin-dev
    ,golang-github-deckarep-golang-set-dev
    ,golang-github-docker-distribution-dev (>= 2.7.1~)
    ,golang-github-docker-docker-credential-helpers-dev (>= 0.6.1~)
    ,golang-github-docker-go-connections-dev (>= 0.4.0~)
    ,golang-github-docker-go-events-dev
    ,golang-github-docker-go-metrics-dev
    ,golang-github-docker-go-units-dev (>= 0.4.0~)
    ,golang-github-docker-libkv-dev
    ,golang-github-docker-libtrust-dev
    ,golang-github-docker-notary-dev
    ,golang-github-fernet-fernet-go-dev
    ,golang-github-fluent-fluent-logger-golang-dev (>= 1.3.0~)
    ,golang-github-fsnotify-fsnotify-dev
    ,golang-github-fvbommel-sortorder-dev
    ,golang-github-gofrs-flock-dev
    ,golang-github-gogo-googleapis-dev
    ,golang-github-golang-groupcache-dev
    ,golang-github-googleapis-gax-go-dev
    ,golang-github-google-go-cmp-dev (>= 0.2.0~)
    ,golang-github-google-shlex-dev
    ,golang-github-google-uuid-dev
    ,golang-github-gorilla-mux-dev (>= 1.7.1~)
    ,golang-github-gotestyourself-gotest.tools-dev
    ,golang-github-graylog2-go-gelf-dev (>= 0.0+git20191017~)
    ,golang-github-grpc-ecosystem-go-grpc-prometheus-dev
    ,golang-github-grpc-ecosystem-go-grpc-middleware-dev
    ,golang-github-grpc-ecosystem-grpc-opentracing-dev
    ,golang-github-hashicorp-memberlist-dev (>= 0.1.0~)
    ,golang-github-hashicorp-serf-dev
    ,golang-github-ishidawataru-sctp-dev
    ,golang-github-imdario-mergo-dev (>= 0.3.3~)
    ,golang-github-json-iterator-go-dev (>= 1.1.4~)
    ,golang-github-miekg-dns-dev (>= 1.1.26~)
    ,golang-github-mitchellh-hashstructure-dev
    ,golang-github-moby-sys-dev
    ,golang-github-moby-term-dev
    ,golang-github-modern-go-reflect2-dev
    ,golang-github-morikuni-aec-dev
    ,golang-github-opencontainers-go-digest-dev
    ,golang-github-opencontainers-image-spec-dev (>= 1.0.1~)
    ,golang-github-opencontainers-runc-dev (>= 1.0.0~rc8~)
    ,golang-github-opencontainers-selinux-dev (>= 1.8.0~)
    ,golang-github-opencontainers-specs-dev (>= 1.0.1~)
    ,golang-github-opentracing-contrib-go-stdlib-dev
    ,golang-github-opentracing-opentracing-go-dev
    ,golang-github-philhofer-fwd-dev
    ,golang-github-prometheus-client-golang-dev (>= 0.9.0~)
    ,golang-github-racksec-srslog-dev
    ,golang-github-samuel-go-zookeeper-dev
    ,golang-github-sirupsen-logrus-dev (>= 1.0.2~)
    ,golang-github-spf13-cobra-dev (>= 1.1.1~)
    ,golang-github-spf13-pflag-dev (>= 1.0.5-2~)
    ,golang-github-tchap-go-patricia-dev
#    ,golang-github-tonistiigi-fsutil-dev (>= 0.0~git20200724~)
    ,golang-github-tonistiigi-units-dev
    ,golang-github-urfave-cli-dev (>= 1.20.0~)
    ,golang-github-vbatts-tar-split-dev (>= 0.11.1~)
    ,golang-github-vishvananda-netlink-dev (>= 1.0.0~)
    ,golang-github-vishvananda-netns-dev (>= 0.0~git20170707~)
    ,golang-github-xeipuuv-gojsonschema-dev (>= 1.2.0~)
#   ,golang-glog-dev
    ,golang-gocapability-dev
    ,golang-golang-x-net-dev
    ,golang-golang-x-oauth2-google-dev | golang-golang-x-oauth2-dev
    ,golang-golang-x-term-dev
    ,golang-golang-x-time-dev
    ,golang-google-api-dev
    ,golang-google-cloud-dev
    ,golang-google-grpc-dev
    ,golang-goprotobuf-dev (>= 0.0~git20151207~)
    ,golang-go-zfs-dev
    ,golang-protobuf-extensions-dev
    ,gotestsum
    ,libapparmor-dev
    ,libbtrfs-dev | btrfs-progs (<< 4.16.1~)
    ,libdevmapper-dev
    ,libseccomp-dev
    ,pkg-config
    ,procps
    ,tzdata
# tests:
    ,git
# swarmkit tests are not run:
#   ,golang-github-onsi-ginkgo-dev
#   ,golang-gomega-dev
# cli/vendor/k8s.io dependencies:
    ,golang-github-davecgh-go-spew-dev
    ,golang-github-evanphx-json-patch-dev (>= 4.1.0~)
    ,golang-github-googleapis-gnostic-dev
    ,golang-github-google-gofuzz-dev
    ,golang-gopkg-inf.v0-dev
#   ,golang-k8s-sigs-structured-merge-diff-dev
    ,golang-k8s-sigs-yaml-dev
Homepage: https://mobyproject.org
Vcs-Browser: https://salsa.debian.org/go-team/packages/docker
Vcs-Git: https://salsa.debian.org/go-team/packages/docker.git
Rules-Requires-Root: no
XS-Go-Import-Path: github.com/docker/docker

Package: docker.io
Architecture: linux-any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends} ,${shlibs:Depends}
    ,adduser
    ,containerd (>= 1.4~)
    ,iptables
    ,lsb-base
    ,runc (>= 1.0.0~rc8~)
    ,tini
Recommends: apparmor
    ,ca-certificates
    ,cgroupfs-mount
    ,git
    ,needrestart (>= 3.1~)
    ,xz-utils
Conflicts:
## Docker's vendor packages:
    docker-ce
    ,docker-ce-cli
    ,docker-ce-rootless-extras
Suggests: docker-doc
    ,aufs-tools
    ,btrfs-progs
    ,debootstrap
    ,e2fsprogs
    ,rinse
    ,rootlesskit
    ,xfsprogs
    ,zfs-fuse | zfsutils-linux
Built-Using: ${libc:Built-Using}, ${misc:Built-Using}
Description: Linux container runtime
 Docker complements kernel namespacing with a high-level API which operates at
 the process level. It runs unix processes with strong guarantees of isolation
 and repeatability across servers.
 .
 Docker is a great building block for automating distributed systems:
 large-scale web deployments, database clusters, continuous deployment systems,
 private PaaS, service-oriented architectures, etc.
 .
 This package contains the daemon and client. Using docker.io on non-amd64 hosts
 is not supported at this time. Please be careful when using it on anything
 besides amd64.
 .
 Also, note that kernel version 3.8 or above is required for proper operation of
 the daemon process, and that any lower versions may have subtle and/or glaring
 issues.

Package: golang-github-docker-docker-dev
Architecture: all
Section: golang
Depends: ${misc:Depends}
    ,golang-github-containerd-containerd-dev (>= 1.4.2~ds1-2~)
    ,golang-github-containerd-continuity-dev (>= 0.0~git20190426~)
    ,golang-github-docker-distribution-dev (>= 2.7.1~)
    ,golang-github-docker-docker-credential-helpers-dev (>= 0.6.1~)
    ,golang-github-docker-go-connections-dev (>= 0.4.0~)
    ,golang-github-docker-go-metrics-dev
    ,golang-github-docker-go-units-dev (>= 0.4.0~)
    ,golang-github-docker-libkv-dev
    ,golang-github-fsnotify-fsnotify-dev
    ,golang-github-gorilla-mux-dev (>= 1.7.1~)
    ,golang-github-moby-term-dev
    ,golang-github-morikuni-aec-dev
    ,golang-github-opencontainers-go-digest-dev
    ,golang-github-opencontainers-image-spec-dev (>= 1.0.1~)
    ,golang-github-opencontainers-runc-dev (>= 1.0.0~rc8~)
    ,golang-github-opencontainers-selinux-dev (>= 1.8.0~)
    ,golang-github-sirupsen-logrus-dev (>= 1.0.2~)
    ,golang-github-tchap-go-patricia-dev
    ,golang-golang-x-net-dev
    ,golang-golang-x-sys-dev (>= 0.0~git20190726~)
    ,golang-google-grpc-dev
# libnetwork:
    ,golang-dbus-dev (>= 5.0.2~)
    ,golang-github-burntsushi-toml-dev
    ,golang-github-deckarep-golang-set-dev
    ,golang-github-docker-go-events-dev
    ,golang-github-hashicorp-memberlist-dev (>= 0.1.0~)
    ,golang-github-hashicorp-serf-dev
    ,golang-github-ishidawataru-sctp-dev
    ,golang-github-vishvananda-netlink-dev (>= 1.0.0~)
    ,golang-github-vishvananda-netns-dev
# moby/buildkit/session
    ,golang-github-opentracing-opentracing-go-dev
Description: reusable Go packages included with Docker
 These packages are intentionally developed by upstream in such a way that they
 are reusable to projects outside Docker and only rely on each other or other
 external dependencies to be built.

Package: docker-doc
Provides: docker.io-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Linux container runtime -- documentation
 Docker complements kernel namespacing with a high-level API which operates at
 the process level. It runs unix processes with strong guarantees of isolation
 and repeatability across servers.
 .
 Docker is a great building block for automating distributed systems:
 large-scale web deployments, database clusters, continuous deployment systems,
 private PaaS, service-oriented architectures, etc.
 .
 This package contains the daemon and client. Using docker.io on non-amd64 hosts
 is not supported at this time. Please be careful when using it on anything
 besides amd64.
 .
 Also, note that kernel version 3.8 or above is required for proper operation of
 the daemon process, and that any lower versions may have subtle and/or glaring
 issues.
 .
 This package provides documentation for Docker.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/default.mk

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# The engine and cli are built and tested using upstream scripts
# and Makefiles, rather than dh_auto_*. Therefore we can't rely
# on dh to set the environment for us, we have to do it here.
export GOPATH := $(CURDIR)/_build
export GOCACHE := $(GOPATH)/go-build
export GO111MODULE := off
export GOPROXY := off

#export DH_GOLANG_BUILDPKG := github.com/docker/docker github.com/docker/cli
export DH_GOLANG_GO_GENERATE := 1
export DH_GOLANG_INSTALL_ALL := 1
export DH_GOLANG_INSTALL_EXTRA := testdata/
export DH_GOLANG_EXCLUDES := \
    integration-cli \
    vendor

# Version and commits
DOCKER_VERSION := $(DEB_VERSION_UPSTREAM)
ENGINE_GITCOMMIT := $(shell ./debian/helpers/gitcommit.sh engine $(DOCKER_VERSION))
ifndef ENGINE_GITCOMMIT
  $(error Missing ENGINE_GITCOMMIT - see debian/helpers/engine-gitcommits)
endif
CLI_GITCOMMIT    := $(shell ./debian/helpers/gitcommit.sh cli $(DOCKER_VERSION))
ifndef CLI_GITCOMMIT
  $(error Missing CLI_GITCOMMIT - see debian/helpers/cli-gitcommits)
endif

# cli does not support SOURCE_DATE_EPOCH
# https://github.com/docker/cli/pull/2855
CLI_BUILDTIME := $(shell date -u -d "@$(SOURCE_DATE_EPOCH)" --rfc-3339 ns | sed -e 's/ /T/')

# engine: have "make.sh" keep "bundle/$(DOCKER_VERSION)" around between runs
# (we clean it up appropriately ourselves)
ENGINE_KEEPBUNDLE := 1

ENGINE_BUILDTAGS := apparmor seccomp
ENGINE_TESTFLAGS := -test.short

BUILT_LIBC := $(shell dpkg-query -f '$${source:Package} (= $${source:Version})' -W libc-dev-bin)

%:
	dh $@ --buildsystem=golang --with=bash-completion,golang --builddirectory=_build

override_dh_golang:
## Set DH_GOLANG_BUILDPKG so that Built-Using is properly generated.
	DH_GOLANG_BUILDPKG="\
	github.com/docker/cli/... github.com/docker/docker/... \
	github.com/docker/libnetwork/... github.com/docker/swarmkit/...\
	" dh_golang -O--buildsystem=golang -O--builddirectory=_build

override_dh_clean:
	dh_clean
	$(RM) -v -r autogen bundles man/man*/
#	-find . -type f -name '*.pb.go' -delete -printf 'removed %p\n'            ## delete generated .pb.go files
	## Remove Files-Excluded (when built from checkout or non-DFSG tarball):
	$(RM) -rv `perl -0nE 'say grep { $$_=q{ */}.$$_ } split(/\s+/,$$1) if m{^Files\-Excluded:\s*(.*?)(?:\n\n|^Files|^Comment:)}sm;' debian/copyright`
	-find */vendor -mindepth 1 -type d -empty -delete -printf 'removed %p\n'

override_dh_auto_configure:
## dh_auto_configure symlinks dirs from "/usr/share/gocode/src" into
## $(GOPATH) unless folders already exist there in which case files
## are copied. Pre-making directories allows us to use debhelper to
## create proper GOPATH source tree yet have certain directories writable
## even if they are provided by already installed package.
	mkdir -pv $(GOPATH)/src/github.com/docker/cli
	mkdir -pv $(GOPATH)/src/github.com/docker/docker
	mkdir -pv $(GOPATH)/src/github.com/docker/libnetwork
	mkdir -pv $(GOPATH)/src/github.com/docker/swarmkit

## Prepare builddirectory but throw away sourcedirectory.
	DH_GOPKG="__IGNORE__" dh_auto_configure

## Each package must be removed from working tree first, in case some
## of the packages that we are going to build are already installed.
## This is also useful for building in unclean environment.
##
## This is _necessary_ to avoid merging packages that we build with
## pre-installed packages. See #827226 for details.
## Debhelper knows only about "main" DH_GOPKG package but we build several
## and we have to ensure that build tree is properly prepared.
	$(RM) -r              $(GOPATH)/src/github.com/docker/cli
	cp -ra  cli           $(GOPATH)/src/github.com/docker/cli

	$(RM) -r              $(GOPATH)/src/github.com/docker/docker
	cp -ra  engine        $(GOPATH)/src/github.com/docker/docker

	$(RM) -r              $(GOPATH)/src/github.com/docker/libnetwork
	cp -ra  libnetwork    $(GOPATH)/src/github.com/docker/libnetwork

	$(RM) -r              $(GOPATH)/src/github.com/docker/swarmkit
	cp -ra  swarmkit      $(GOPATH)/src/github.com/docker/swarmkit

override_dh_auto_build:
## Order is important:

	DH_GOPKG="github.com/docker/libnetwork"                dh_auto_build -v

##	## FIXME: DH_GOLANG_BUILDPKG --> DH_GOPKG
	DH_GOLANG_BUILDPKG="github.com/docker/swarmkit"        dh_auto_build -v

##	build ("cd" first to ensure we build from within GOPATH)
	cd '$(GOPATH)/src/github.com/docker/docker' \
        && KEEPBUNDLE=$(ENGINE_KEEPBUNDLE) VERSION=$(DOCKER_VERSION) DOCKER_BUILDTAGS='$(ENGINE_BUILDTAGS)' \
	   DOCKER_GITCOMMIT=$(ENGINE_GITCOMMIT) PRODUCT=docker ./hack/make.sh dynbinary
	
	cd '$(GOPATH)/src/github.com/docker/cli' \
        && LDFLAGS='' DISABLE_WARN_OUTSIDE_CONTAINER=1 BUILDTIME='$(CLI_BUILDTIME)' \
           $(MAKE) VERSION=$(DOCKER_VERSION) GITCOMMIT=$(CLI_GITCOMMIT) dynbinary manpages
	
override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	## Test engine:
	cd $(GOPATH)/src/github.com/docker/docker \
        && TESTFLAGS='$(ENGINE_TESTFLAGS)' ./hack/test/unit

	## Test CLI:
	cd $(GOPATH)/src/github.com/docker/cli \
        && DISABLE_WARN_OUTSIDE_CONTAINER=1 $(MAKE) test-unit
endif

override_dh_install:
	## Rename binaries
	cd $(GOPATH)/src/github.com/docker/docker/bundles/dynbinary-daemon \
	&& mv dockerd-$(DOCKER_VERSION) dockerd
	cd $(GOPATH)/src/github.com/docker/cli/build \
	&& mv docker-linux-$$(go env GOHOSTARCH) docker
	cd $(GOPATH)/bin \
	&& mv proxy docker-proxy
	## Do not install extra license files:
	dh_install -XLICENSE
	## Apparmor thing, not sure it's needed, we don't install a profile
	dh_apparmor --profile-name=docker.io -pdocker.io

override_dh_auto_install:
	## skip dh_auto_install to stop dh_golang trying to copy bits
	## for /usr/share/gocode (we use dh_install for that)

override_dh_installinit:
	dh_installinit -v --name=docker --no-stop-on-upgrade --no-restart-after-upgrade

override_dh_installsystemd:
	dh_installsystemd -v --name=docker --no-stop-on-upgrade --no-restart-after-upgrade

override_dh_installudev:
	# use priority z80 to match the upstream priority of 80
	dh_installudev -v --name=docker --priority=z80

override_dh_gencontrol:
	echo 'libc:Built-Using=$(BUILT_LIBC)' >> debian/docker.io.substvars
	dh_gencontrol

## docker.io 20.10.7

=== debian/changelog ===
docker.io (20.10.7-0ubuntu5.1) impish-security; urgency=medium

  * SECURITY UPDATE: docker cli information disclosure on misconfiguration
    - d/p/CVE-2021-41092.patch: Ensure that default authentication config
      has an address.
    - CVE-2021-41092

 -- Ray Veldkamp <ray.veldkamp@canonical.com>  Fri, 22 Oct 2021 10:58:58 +1100

docker.io (20.10.7-0ubuntu5) impish; urgency=medium

  [ Sergio Durigan Junior ]
  * d/t/docker-in-lxd:
    Improve dep8 test.  Make it run a more complex test against an
    ubuntu:devel docker container, especially because glibc updates might
    break docker.io.  Improve test reliability when running autopkgtest
    locally.

  [ Steve Beattie ]
  * SECURITY UPDATE: insufficiently restricted directory permissions
    - d/p/CVE-2021-41091.patch: Lock down docker root dir perms.
    - CVE-2021-41091
  * SECURITY UPDATE: permissions modifications outside of install directory
    - d/p/CVE-2021-41089.patch: chrootarchive: don't create parent dirs
      outside of chroot.
    - CVE-2021-41089

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Tue, 05 Oct 2021 16:45:26 -0300

docker.io (20.10.7-0ubuntu4) impish; urgency=medium

  * d/p/seccomp-add-support-for-clone3-syscall-in-default-policy.patch: Fix
    failure with new glibc clone3 syscall adding it to the default seccomp
    policy (LP: #1943049).

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Fri, 10 Sep 2021 15:34:38 -0300

docker.io (20.10.7-0ubuntu3) impish; urgency=medium

  * d/t/docker-in-lxd:
    Perform a full upgrade and restart of the container before attempting
    to install docker.io. (LP: #1942276)

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Wed, 01 Sep 2021 18:58:31 -0400

docker.io (20.10.7-0ubuntu2) impish; urgency=medium

  * Ship libnetwork into the golang-github-docker-docker-dev package.
    - d/golang-github-docker-docker-dev.install: add libnetwork directories.
    - d/control: add runtime dependency on golang-github-ishidawataru-sctp-dev

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Fri, 28 May 2021 10:55:12 -0300

docker.io (20.10.7-0ubuntu1) impish; urgency=medium

  * New upstream release.
    - Among new features and bug fixes, the CVE-2021-21284 and CVE-2021-21285
      were addressed.
  * d/watch: adjust regex to correctly match the tarball files.
  * d/rules: make some improvements.
    - Adjust regex in the build-manpages target due to some upstream changes.
    - Separately install the systemd service and socket.
    - Tell dh_installsystemd to not stop the service during the upgrade.
      The previous implementation worked fine until debhelper compat 10 where
      dh_systemd_start was still a thing. In compat 11, it was deprecated
      which means that piece of code was not called.

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Tue, 03 Aug 2021 15:58:42 -0300

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/pkg-info.mk

export VERSION := $(DEB_VERSION_UPSTREAM)

export DOCKER_GITCOMMIT := $(DEB_VERSION)

# temporary build path (see http://golang.org/doc/code.html#GOPATH)
OUR_GOPATH := $(CURDIR)/.gopath
export GOPATH := $(OUR_GOPATH)
export GOCACHE := $(CURDIR)/.gocache

# AppArmor can be optionally used in Debian and is there by default in Ubuntu, so we need support for it compiled into our binary
# same story with SELinux
export DOCKER_BUILDTAGS := apparmor seccomp selinux

ifneq (,$(filter parallel=%, $(DEB_BUILD_OPTIONS)))
	NUMJOBS := $(patsubst parallel=%, %, $(filter parallel=%, $(DEB_BUILD_OPTIONS)))
	MAKEFLAGS += -j '$(NUMJOBS)'
endif

# build explicitly against Go 1.13 (for now):
#   https://github.com/moby/moby/pull/40353
#   https://github.com/containerd/containerd/issues/4509
#   https://github.com/containerd/containerd/pull/4050
#   https://github.com/golang/go/issues/37942
export PATH := /usr/lib/go-1.13/bin:$(PATH)

override_dh_gencontrol:
	# if we're on Ubuntu, we need to Recommends: apparmor
	echo 'apparmor:Recommends=$(shell dpkg-vendor --is Ubuntu && echo apparmor)' >> debian/docker.io.substvars
	echo 'libc:Built-Using=$(shell dpkg-query -f '$${source:Package} (= $${source:Version})' -W libc-dev-bin)' >> debian/docker.io.substvars
	# use "dh_golang" to generate "misc:Built-Using" (via "go list")
	DH_GOLANG_BUILDPKG=' \
		-tags "$(DOCKER_BUILDTAGS)" \
		github.com/docker/docker/cmd/dockerd \
		github.com/docker/cli/cmd/docker \
		github.com/docker/libnetwork/cmd/proxy \
	' dh_golang --builddirectory='$(OUR_GOPATH:$(CURDIR)/%=%)'
	dh_gencontrol

override_dh_auto_configure:
	# set up GOPATH symlink farm
	# libnetwork
	mkdir -p '$(OUR_GOPATH)/src/github.com/docker'
	ln -sfT '$(CURDIR)/libnetwork' '$(OUR_GOPATH)/src/github.com/docker/libnetwork'
	# cli
	mkdir -p '$(OUR_GOPATH)/src/github.com/docker'
	ln -sfT '$(CURDIR)/cli' '$(OUR_GOPATH)/src/github.com/docker/cli'
	# engine
	mkdir -p '$(OUR_GOPATH)/src/github.com/docker'
	ln -sfT '$(CURDIR)/engine' '$(OUR_GOPATH)/src/github.com/docker/docker'

override_dh_auto_build: _build-tini _build-proxy _build-cli _build-manpages _build-engine
	@#

# several "supporting binaries" need to be built and installed
# (https://github.com/docker/docker-ce/tree/v19.03.6/components/engine/hack/dockerfile/install)

_build-tini: # (docker-init)
	mkdir -p tini/build
	cd tini/build \
		&& cmake .. \
		&& make tini-static

_build-proxy: # (from libnetwork)
	go build -o libnetwork/docker-proxy github.com/docker/libnetwork/cmd/proxy

_build-cli:
	DISABLE_WARN_OUTSIDE_CONTAINER=1 \
		make -C cli \
			LDFLAGS='' \
			VERSION='$(VERSION)' \
			GITCOMMIT='$(DOCKER_GITCOMMIT)' \
			dynbinary

# https://github.com/docker/docker-ce/blob/v19.03.6/components/cli/scripts/docs/generate-man.sh
# (replacing hard-coded "/tmp/gen-manpages" with "debian/tmp/gen-manpages")
_build-manpages:
	cd '$(OUR_GOPATH)/src/github.com/docker/cli' \
		&& export PATH='$(OUR_GOPATH)/bin':"$$PATH" \
		&& sed 's!/tmp/gen-manpages!$(CURDIR)/debian/tmp/gen-manpages!g' scripts/docs/generate-man.sh \
		&& sed 's!/go/bin/go-md2man!$(OUR_GOPATH)/bin/go-md2man!g' scripts/docs/generate-man.sh \
			| bash

_build-engine:
	cd engine \
		&& PRODUCT=docker ./hack/make.sh dynbinary

# basic smoke test to ensure binaries built successfully
# (especially since their actual tests are *really* involved)
override_dh_auto_test:
	# tini
	./tini/build/tini-static --version
	# cli
	./cli/build/docker --version
	# engine
	./engine/bundles/dynbinary-daemon/dockerd --version

override_dh_strip:
	# Go has lots of problems with stripping, so just don't

override_dh_auto_install:
	# we use dh_install / dh-exec for installing files where they need to be

# "--no-start" because we have a debconf prompt to determine whether to restart during upgrades
# (which means we get to handle both "start" and "stop" ourselves too)
override_dh_installinit:
	dh_installinit --name=docker --no-start

override_dh_installsystemd:
	# We take care of determining whether the docker.io service should be
	# restarted during upgrades or not ourselves, based on the debconf
	# choice made by the user during installation.  For this reason, we
	# invoke dh_installsystemd with "--no-stop-on-upgrade" in order
	# to avoid indiscriminately stopping the service during upgrades.
	dh_installsystemd --name=docker --no-start -pdocker.io --no-stop-on-upgrade docker.service
	dh_installsystemd --name=docker --no-start -pdocker.io --no-stop-on-upgrade docker.socket

override_dh_installudev:
	# use priority z80 to match the upstream priority of 80
	dh_installudev --priority=z80

override_dh_install:
	dh_install
	dh_apparmor --profile-name=docker.io -pdocker.io

override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info

override_dh_auto_clean:
	@# stop debhelper from doing "make clean"

%:
	dh $@ --with=bash-completion

=== debian/tests/control ===
Tests: basic-smoke
Depends: aufs-tools, debian-archive-keyring, debootstrap, @
Restrictions: allow-stderr isolation-machine needs-root

Tests: docker-in-lxd
Depends: dctrl-tools, lxd
Restrictions: allow-stderr isolation-machine needs-root

#Tests: integration
#Depends: ca-certificates, curl, git, golang-check.v1-dev, jq, @, @builddeps@
#Restrictions: allow-stderr isolation-machine needs-root rw-build-tree

## docker.io 20.10.12

=== Makefile ===
.PHONY: all all-local build build-local clean cross cross-local vet lint misspell check check-local check-code check-format unit-tests protobuf protobuf-local check-protobuf
SHELL=/bin/bash

dockerbuildargs ?= --target dev - < Dockerfile
dockerargs ?= --privileged -v $(shell pwd):/go/src/github.com/docker/libnetwork -w /go/src/github.com/docker/libnetwork
build_image=libnetworkbuild
container_env = -e "INSIDECONTAINER=-incontainer=true"
docker = docker run --rm -it --init ${dockerargs} $$EXTRA_ARGS ${container_env} ${build_image}

CROSS_PLATFORMS = linux/amd64 linux/386 linux/arm windows/amd64
PACKAGES=$(shell go list ./... | grep -v /vendor/)
PROTOC_FLAGS=-I=. -I=/go/src -I=/go/src/github.com/gogo/protobuf -I=/go/src/github.com/gogo/protobuf/protobuf

export PATH := $(CURDIR)/bin:$(PATH)


# Several targets in this Makefile expect to run within the
# libnetworkbuild container.   In general, a target named '<target>-local'
# relies on utilities inside the build container.   Usually there is also
# a wrapper called '<target>' which starts a container and runs
# 'make <target>-local' inside it.

###########################################################################
# Top level targets
###########################################################################

all: build check clean

all-local: build-local check-local clean


###########################################################################
# Build targets
###########################################################################

# builder builds the libnetworkbuild container.  All wrapper targets
# must depend on this to ensure that the container exists.
builder:
	DOCKER_BUILDKIT=1 docker build --progress=plain  -t ${build_image} --build-arg=GO_VERSION ${dockerbuildargs}

build: builder
	@echo "🐳 $@"
	@${docker} make build-local

build-local:
	@echo "🐳 $@"
	@mkdir -p "bin"
	go build -tags experimental -o "bin/dnet" ./cmd/dnet
	go build -o "bin/docker-proxy" ./cmd/proxy
	CGO_ENABLED=0 go build -o "bin/diagnosticClient" ./cmd/diagnostic
	CGO_ENABLED=0 go build -o "bin/testMain" ./cmd/networkdb-test/testMain.go

build-images:
	@echo "🐳 $@"
	cp cmd/diagnostic/daemon.json ./bin
	DOCKER_BUILDKIT=1 docker build --progress=plain  -f cmd/diagnostic/Dockerfile.client -t dockereng/network-diagnostic:onlyclient bin/
	DOCKER_BUILDKIT=1 docker build --progress=plain  -f cmd/diagnostic/Dockerfile.dind -t dockereng/network-diagnostic:17.12-dind bin/
	DOCKER_BUILDKIT=1 docker build --progress=plain  -f cmd/networkdb-test/Dockerfile -t dockereng/e2e-networkdb:master bin/
	DOCKER_BUILDKIT=1 docker build --progress=plain  -t dockereng/network-diagnostic:support.sh support/

push-images: build-images
	@echo "🐳 $@"
	docker push dockereng/network-diagnostic:onlyclient
	docker push dockereng/network-diagnostic:17.12-dind
	docker push dockereng/e2e-networkdb:master
	docker push dockereng/network-diagnostic:support.sh

clean:
	@echo "🐳 $@"
	@if [ -d bin ]; then \
		echo "Removing binaries"; \
		rm -rf bin; \
	fi

cross: builder
	@mkdir -p "bin"
	@for platform in ${CROSS_PLATFORMS}; do \
		EXTRA_ARGS="-e GOOS=$${platform%/*} -e GOARCH=$${platform##*/}" ; \
		echo "$${platform}..." ; \
		${docker} make cross-local ; \
	done

cross-local:
	@echo "🐳 $@"
	go build -o "bin/dnet-$$GOOS-$$GOARCH" ./cmd/dnet
	go build -o "bin/docker-proxy-$$GOOS-$$GOARCH" ./cmd/proxy

# Rebuild protocol buffers.
# These may need to be rebuilt after vendoring updates, so .proto files are declared .PHONY so they are always rebuilt.
PROTO_FILES=$(shell find . -path ./vendor -prune -o -name \*.proto -print)
PB_FILES=$(PROTO_FILES:.proto=.pb.go)

# Pattern rule for protoc.   If PROTOC_CHECK is defined, it checks
# whether the generated files are up to date and fails if they are not
%.pb.go: %.proto
	@if [ ${PROTOC_CHECK} ]; then \
	protoc ${PROTOC_FLAGS} --gogo_out=/tmp $< ; \
	diff -q $@ /tmp/$@ >/dev/null || (echo "👹 $@ is out of date; please run 'make protobuf' and check in updates" && exit 1) ; \
	else \
	protoc ${PROTOC_FLAGS} --gogo_out=./ $< ; \
	fi

.PHONY: $(PROTO_FILES)
protobuf: builder
	@${docker} make protobuf-local
protobuf-local: $(PB_FILES)


###########################################################################
# Test targets
###########################################################################

check: builder
	@${docker} make check-local

check-local: check-code check-format

check-code: check-protobuf lint vet ineffassign

check-format: fmt misspell

unit-tests: builder
	${docker} make unit-tests-local

unit-tests-local:
	@echo "🐳 Running tests... "
	@echo "mode: count" > coverage.coverprofile
	@go build -o "bin/docker-proxy" ./cmd/proxy
	@for dir in $$( find . -maxdepth 10 -not -path './.git*' -not -path '*/_*' -not -path './vendor/*' -type d); do \
	if ls $$dir/*.go &> /dev/null; then \
		pushd . &> /dev/null ; \
		cd $$dir ; \
		go test ${INSIDECONTAINER} -test.parallel 5 -test.v -covermode=count -coverprofile=./profile.tmp ; \
		ret=$$? ;\
		if [ $$ret -ne 0 ]; then exit $$ret; fi ;\
		popd &> /dev/null; \
		if [ -f $$dir/profile.tmp ]; then \
			cat $$dir/profile.tmp | tail -n +2 >> coverage.coverprofile ; \
				rm $$dir/profile.tmp ; \
	    fi ; \
	fi ; \
	done
	@echo "Done running tests"

# Depends on binaries because vet will silently fail if it can not load compiled imports
vet: ## run go vet
	@echo "🐳 $@"
	@test -z "$$(go vet ${PACKAGES} 2>&1 | grep -v 'constant [0-9]* not a string in call to Errorf' | egrep -v '(timestamp_test.go|duration_test.go|exit status 1)' | tee /dev/stderr)"

misspell:
	@echo "🐳 $@"
	@test -z "$$(find . -type f | grep -v vendor/ | grep "\.go\|\.md" | xargs misspell -error | tee /dev/stderr)"

fmt: ## run go fmt
	@echo "🐳 $@"
	@test -z "$$(gofmt -s -l . | grep -v vendor/ | grep -v ".pb.go$$" | tee /dev/stderr)" || \
		(echo "👹 please format Go code with 'gofmt -s -w'" && false)

lint: ## run go lint
	@echo "🐳 $@"
	@test -z "$$(golint ./... | grep -v vendor/ | grep -v ".pb.go:" | grep -v ".mock.go" | tee /dev/stderr)"

ineffassign: ## run ineffassign
	@echo "🐳 $@"
	@test -z "$$(ineffassign . | grep -v vendor/ | grep -v ".pb.go:" | grep -v ".mock.go" | tee /dev/stderr)"

# check-protobuf rebuilds .pb.go files and fails if they have changed
check-protobuf: PROTOC_CHECK=1
check-protobuf: $(PB_FILES)
	@echo "🐳 $@"


###########################################################################
# Utility targets
###########################################################################

shell: builder
	@${docker} ${SHELL}

=== debian/changelog ===
docker.io (20.10.12-0ubuntu4) jammy; urgency=medium

  * Enable riscv64 architecture (LP: #1963920)

 -- Heinrich Schuchardt <heinrich.schuchardt@canonical.com>  Mon, 07 Mar 2022 16:57:50 +0100

docker.io (20.10.12-0ubuntu2) jammy; urgency=medium

  * d/t/docker-in-lxd: Match "file:/" instead of "file:///" on
    copy_local_apt_files.
    The command "apt-get indextargets" returns a URI field with "file:/"
    as the prefix.  We've been trying to match "file:///", which is
    sometimes unsuccessful and leads to errors because the local apt cache
    is not copied over to the container.  We can use "file:/" instead,
    which will work on both scenarios.  It's also not a problem to just
    strip the "file:" prefix, because even paths like "///var/cache" are
    correctly resolved by the filesystem.

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Fri, 14 Jan 2022 14:30:44 -0500

docker.io (20.10.12-0ubuntu1) jammy; urgency=medium

  * New upstream release.
  * Remove all patches, applied by upstream.
  * Build depend on default golang 1.17.
  * d/rules: set GO111MODULE to auto.

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Mon, 10 Jan 2022 18:08:58 -0300

docker.io (20.10.7-0ubuntu7) jammy; urgency=medium

  * SECURITY UPDATE: docker cli information disclosure on misconfiguration
    - d/p/CVE-2021-41092.patch: Ensure that default authentication config
    has an address.
    - CVE-2021-41092

 -- Ray Veldkamp <ray.veldkamp@canonical.com>  Fri, 22 Oct 2021 17:03:30 +1100

docker.io (20.10.7-0ubuntu6) devel; urgency=medium

  * d/t/control: Drop unused aufs-tools as a test dependency (LP: #1947004)

 -- Lukas Märdian <slyon@ubuntu.com>  Wed, 13 Oct 2021 17:22:20 +0200

=== debian/control ===
Source: docker.io
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Paul Tagliamonte <paultag@debian.org>
Uploaders: Docker Packaging Team <docker-maint@lists.alioth.debian.org>,
           Tianon Gravi <tianon@debian.org>
Build-Conflicts: golang-github-docker-docker-dev
Build-Depends: bash-completion,
               ca-certificates,
               cmake,
               debconf (>= 0.5),
               debhelper (>= 11),
               dh-apparmor,
               dh-exec,
               dh-golang,
               git,
               golang-go,
               libapparmor-dev,
               libbtrfs-dev | btrfs-progs (<< 4.16.1~),
               libdevmapper-dev (>= 2:1.02.68~),
               libltdl-dev,
               libseccomp-dev,
               libsystemd-dev (>= 209~),
               pkg-config,
               procps,
               tzdata
Standards-Version: 3.9.8
Homepage: https://www.docker.com/community-edition
Vcs-Git: https://anonscm.debian.org/git/docker/docker.io.git
Vcs-Browser: https://anonscm.debian.org/cgit/docker/docker.io.git
XS-Go-Import-Path: github.com/docker/docker

Package: docker.io
Architecture: amd64 arm64 armhf i386 ppc64el riscv64 s390x
Depends: adduser,
         containerd (>= 1.2.6-0ubuntu1~),
         iptables,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: ca-certificates,
            git,
            pigz,
            ubuntu-fan,
            xz-utils,
            ${apparmor:Recommends}
Replaces: docker (<< 1.5~)
Breaks: docker (<< 1.5~)
Suggests: aufs-tools,
          btrfs-progs,
          cgroupfs-mount | cgroup-lite,
          debootstrap,
          docker-doc,
          rinse,
          zfs-fuse | zfsutils
Built-Using: ${libc:Built-Using}, ${misc:Built-Using}
Description: Linux container runtime
 Docker complements kernel namespacing with a high-level API which operates at
 the process level. It runs unix processes with strong guarantees of isolation
 and repeatability across servers.
 .
 Docker is a great building block for automating distributed systems:
 large-scale web deployments, database clusters, continuous deployment systems,
 private PaaS, service-oriented architectures, etc.
 .
 This package contains the daemon and client. Using docker.io on non-amd64 hosts
 is not supported at this time. Please be careful when using it on anything
 besides amd64.
 .
 Also, note that kernel version 3.8 or above is required for proper operation of
 the daemon process, and that any lower versions may have subtle and/or glaring
 issues.

Package: vim-syntax-docker
Architecture: all
Depends: vim, ${misc:Depends}
Recommends: vim-addon-manager
Suggests: docker.io
Description: Docker container engine - Vim highlighting syntax files
 This package provides syntax files for the Vim editor for editing Dockerfiles
 from the Docker container engine.

Package: golang-github-docker-docker-dev
Architecture: all
Depends: golang-github-ishidawataru-sctp-dev,
         golang-github-docker-docker-credential-helpers-dev,
         golang-github-seccomp-libseccomp-golang-dev,
         ${misc:Depends}
Replaces: golang-docker-dev (<< 1.8.2~ds1-1~)
Breaks: golang-docker-dev (<< 1.8.2~ds1-1~)
Provides: golang-docker-dev
Description: Externally reusable Go packages included with Docker
 These packages are intentionally developed by upstream in such a way that they
 are reusable to projects outside Docker and only rely on each other or other
 external dependencies to be built.

Package: golang-docker-dev
Section: oldlibs
Priority: optional
Architecture: all
Depends: golang-github-docker-docker-dev, ${misc:Depends}
Description: Transitional package for golang-github-docker-docker-dev
 This is a transitional package to ease upgrades to the
 golang-github-docker-docker-dev package. It can safely be removed.

Package: docker-doc
Provides: docker.io-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Linux container runtime -- documentation
 Docker complements kernel namespacing with a high-level API which operates at
 the process level. It runs unix processes with strong guarantees of isolation
 and repeatability across servers.
 .
 Docker is a great building block for automating distributed systems:
 large-scale web deployments, database clusters, continuous deployment systems,
 private PaaS, service-oriented architectures, etc.
 .
 This package contains the daemon and client. Using docker.io on non-amd64 hosts
 is not supported at this time. Please be careful when using it on anything
 besides amd64.
 .
 Also, note that kernel version 3.8 or above is required for proper operation of
 the daemon process, and that any lower versions may have subtle and/or glaring
 issues.
 .
 This package provides documentation for Docker.

=== debian/rules ===
--- 
+++ 
@@ -12,6 +12,9 @@
 export GOPATH := $(OUR_GOPATH)
 export GOCACHE := $(CURDIR)/.gocache
 
+# https://blog.golang.org/go116-module-changes (TODO figure out a new solution for Go 1.17+)
+export GO111MODULE := auto
+
 # AppArmor can be optionally used in Debian and is there by default in Ubuntu, so we need support for it compiled into our binary
 # same story with SELinux
 export DOCKER_BUILDTAGS := apparmor seccomp selinux
@@ -20,13 +23,6 @@
 	NUMJOBS := $(patsubst parallel=%, %, $(filter parallel=%, $(DEB_BUILD_OPTIONS)))
 	MAKEFLAGS += -j '$(NUMJOBS)'
 endif
-
-# build explicitly against Go 1.13 (for now):
-#   https://github.com/moby/moby/pull/40353
-#   https://github.com/containerd/containerd/issues/4509
-#   https://github.com/containerd/containerd/pull/4050
-#   https://github.com/golang/go/issues/37942
-export PATH := /usr/lib/go-1.13/bin:$(PATH)
 
 override_dh_gencontrol:
 	# if we're on Ubuntu, we need to Recommends: apparmor
